<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/bele.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>bele.c</h1><a href="bele_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">/*</span>
<a name="l00028"></a>00028 <span class="comment">  hybrid FEM/BEM method from:</span>
<a name="l00029"></a>00029 <span class="comment">  T. R. Koehler, D. R. Fredkin, &quot;Finite Element Methods for</span>
<a name="l00030"></a>00030 <span class="comment">  Micromagnetics&quot;, IEEE Trans. Magn. 28 (1992) 1239-1244</span>
<a name="l00031"></a>00031 <span class="comment"></span>
<a name="l00032"></a>00032 <span class="comment">  matrix elements calculated according to:</span>
<a name="l00033"></a>00033 <span class="comment">  D. A. Lindholm, &quot;Three-Dimensional Magnetostatic Fields from</span>
<a name="l00034"></a>00034 <span class="comment">  Point-Matched Integral Equations with Linearly Varying Scalar</span>
<a name="l00035"></a>00035 <span class="comment">  Sources&quot;, IEEE Trans. Magn. MAG-20 (1984) 2025-2032.</span>
<a name="l00036"></a>00036 <span class="comment">*/</span>
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="field_8h.html#affb52b9f2b0f2fd0d97c0519704464c8">00038</a> <span class="keywordtype">int</span> <a class="code" href="bele_8c.html#affb52b9f2b0f2fd0d97c0519704464c8">Bele</a>(PetscReal* bvert,PetscReal* facv1,PetscReal* facv2,PetscReal* facv3,PetscReal* matele)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   PetscReal   *rr,zeta[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],zetal;
<a name="l00041"></a>00041   PetscReal   rho1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],rho2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],rho3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00042"></a>00042   PetscReal   rho1l,rho2l,rho3l;
<a name="l00043"></a>00043   PetscReal   s1,s2,s3;
<a name="l00044"></a>00044   PetscReal   eta1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],eta2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],eta3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00045"></a>00045   PetscReal   eta1l,eta2l,eta3l;
<a name="l00046"></a>00046   PetscReal   xi1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],xi2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],xi3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00047"></a>00047   PetscReal   gamma1[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],gamma2[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],gamma3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00048"></a>00048   PetscReal   p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>],a,omega;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   matele[0]=matele[1]=matele[2]=0.0;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">/* get coordinates of face&#39;s vertices */</span>
<a name="l00053"></a>00053   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,facv1,1,rho1,1);
<a name="l00054"></a>00054   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,facv2,1,rho2,1);
<a name="l00055"></a>00055   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,facv3,1,rho3,1);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">/* calculate edge vectors and store them in xi_j */</span>
<a name="l00058"></a>00058   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho2,1,xi1,1);
<a name="l00059"></a>00059   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,rho1,1,xi1,1);
<a name="l00060"></a>00060   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho3,1,xi2,1);
<a name="l00061"></a>00061   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,rho2,1,xi2,1);
<a name="l00062"></a>00062   <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho1,1,xi3,1);
<a name="l00063"></a>00063   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,rho3,1,xi3,1);
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">/* calculate zeta direction */</span>
<a name="l00066"></a>00066   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi1,xi2,zeta);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">/* calculate area of the triangle */</span>
<a name="l00069"></a>00069   zetal=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,zeta,1);
<a name="l00070"></a>00070   a=0.5*zetal;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">/* renorm zeta */</span>
<a name="l00073"></a>00073   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/zetal,zeta,1);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">/* calculate s_j and normalize xi_j */</span>
<a name="l00076"></a>00076   s1=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi1,1);
<a name="l00077"></a>00077   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/s1,xi1,1);
<a name="l00078"></a>00078   s2=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi2,1);
<a name="l00079"></a>00079   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/s2,xi2,1);
<a name="l00080"></a>00080   s3=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi3,1);
<a name="l00081"></a>00081   <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/s3,xi3,1);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,zeta,xi1,eta1);
<a name="l00084"></a>00084   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,zeta,xi2,eta2);
<a name="l00085"></a>00085   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,zeta,xi3,eta3);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   gamma1[0]=gamma3[1]=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi2,1,xi1,1);
<a name="l00088"></a>00088   gamma1[1]=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi2,1,xi2,1);
<a name="l00089"></a>00089   gamma1[2]=gamma2[1]=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi2,1,xi3,1);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   gamma2[0]=gamma3[2]=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi3,1,xi1,1);
<a name="l00092"></a>00092   gamma2[2]=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi3,1,xi3,1);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   gamma3[0]=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,xi1,1,xi1,1);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">/* get R=rr */</span>
<a name="l00097"></a>00097   rr=bvert;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   PetscReal d;
<a name="l00100"></a>00100   <a class="code" href="solidangle_8c.html#a11f1b219c8bea88b0d4efaa49d9e109e">PointFromPlane</a>(rr,rho1,rho2,rho3,&amp;d);
<a name="l00101"></a>00101   <span class="keywordflow">if</span> (PetscAbsReal(d)&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) <span class="keywordflow">return</span>(0);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">/* calculate rho_j */</span>
<a name="l00104"></a>00104   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,rr,1,rho1,1);
<a name="l00105"></a>00105   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,rr,1,rho2,1);
<a name="l00106"></a>00106   <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,rr,1,rho3,1);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">/* zetal gives (&quot;normal&quot;) distance of R from the plane of the triangle */</span>
<a name="l00109"></a>00109   zetal=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,zeta,1,rho1,1);
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">/* skip the rest if zetal==0 (R in plane of the triangle)</span>
<a name="l00112"></a>00112 <span class="comment">     -&gt; omega==0 and zetal==0 -&gt; matrix entry=0</span>
<a name="l00113"></a>00113 <span class="comment">  */</span>
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (PetscAbsReal(zetal)&lt;=<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00115"></a>00115     <span class="keywordflow">return</span>(0);
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   rho1l=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho1,1);
<a name="l00119"></a>00119   rho2l=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho2,1);
<a name="l00120"></a>00120   rho3l=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho3,1);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   PetscReal t_nom,t_denom;
<a name="l00123"></a>00123   t_nom=
<a name="l00124"></a>00124     rho1l*rho2l*rho3l+
<a name="l00125"></a>00125     rho1l*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho2,1,rho3,1)+
<a name="l00126"></a>00126     rho2l*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho3,1,rho1,1)+
<a name="l00127"></a>00127     rho3l*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho1,1,rho2,1);
<a name="l00128"></a>00128   t_denom=
<a name="l00129"></a>00129     sqrt(2.0*
<a name="l00130"></a>00130       (rho2l*rho3l+<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho2,1,rho3,1))*
<a name="l00131"></a>00131       (rho3l*rho1l+<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho3,1,rho1,1))*
<a name="l00132"></a>00132       (rho1l*rho2l+<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,rho1,1,rho2,1))
<a name="l00133"></a>00133     );
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">/* catch special cases where the argument of acos</span>
<a name="l00136"></a>00136 <span class="comment">     is close to -1.0 or 1.0 or even outside this interval</span>
<a name="l00137"></a>00137 <span class="comment"></span>
<a name="l00138"></a>00138 <span class="comment">     use 0.0 instead of D_EPS?</span>
<a name="l00139"></a>00139 <span class="comment">     fixes problems with demag field calculation</span>
<a name="l00140"></a>00140 <span class="comment">     suggested by Hiroki Kobayashi, Fujitsu</span>
<a name="l00141"></a>00141 <span class="comment">  */</span>
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (t_nom/t_denom&lt;-1.0) {
<a name="l00143"></a>00143     omega=(zetal &gt;= 0.0 ? 1.0 : -1.0)*2.0*PETSC_PI;
<a name="l00144"></a>00144   }
<a name="l00145"></a>00145   <span class="comment">/* this case should not occur, but does - e.g. examples1/headfield */</span>
<a name="l00146"></a>00146   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (t_nom/t_denom&gt;1.0) {
<a name="l00147"></a>00147     <span class="keywordflow">return</span>(0);
<a name="l00148"></a>00148   }
<a name="l00149"></a>00149   <span class="keywordflow">else</span> {
<a name="l00150"></a>00150     omega=(zetal &gt;= 0.0 ? 1.0 : -1.0)*2.0*acos(t_nom/t_denom);
<a name="l00151"></a>00151   }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   eta1l=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,eta1,1,rho1,1);
<a name="l00154"></a>00154   eta2l=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,eta2,1,rho2,1);
<a name="l00155"></a>00155   eta3l=<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,eta3,1,rho3,1);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   p[0]=log((rho1l+rho2l+s1)/(rho1l+rho2l-s1));
<a name="l00158"></a>00158   p[1]=log((rho2l+rho3l+s2)/(rho2l+rho3l-s2));
<a name="l00159"></a>00159   p[2]=log((rho3l+rho1l+s3)/(rho3l+rho1l-s3));
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   matele[0]=(eta2l*omega-zetal*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,gamma1,1,p,1))*s2/(8.0*PETSC_PI*a);
<a name="l00162"></a>00162   matele[1]=(eta3l*omega-zetal*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,gamma2,1,p,1))*s3/(8.0*PETSC_PI*a);
<a name="l00163"></a>00163   matele[2]=(eta1l*omega-zetal*<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,gamma3,1,p,1))*s1/(8.0*PETSC_PI*a);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">return</span>(0);
<a name="l00166"></a>00166 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

